// Generated by CoffeeScript 1.10.0
(function() {
  var dirExists, ensurePaths, fs, path;

  fs = require('safefs');

  path = require('path');

  dirExists = function(pathname) {
    var error, stats;
    try {
      stats = fs.statSync(pathname);
      return stats.isDirectory();
    } catch (error) {
      return false;
    }
  };

  ensurePaths = function(docpad, plugin) {
    var config, docpadConfig, i, item, newPath, pth, ref, results;
    docpadConfig = docpad.getConfig();
    config = plugin.getConfig();
    if (process.env.OPENSHIFT_DATA_DIR && !config.dataPath) {
      config.dataPath = process.env.OPENSHIFT_DATA_DIR;
    } else if (!config.dataPath) {
      config.dataPath = path.resolve(docpadConfig.rootPath, 'data');
    }
    if (config.saveVersions) {
      newPath = path.join(plugin.config.dataPath, 'versions');
      fs.ensurePath(newPath, function(err, exists) {
        if (err) {
          return docpad.log('warn', err);
        }
      });
    }
    ref = docpadConfig.documentsPaths;
    results = [];
    for (i in ref) {
      item = ref[i];
      pth = path.join(item, config.defaultSavePath);
      if (dirExists(pth)) {
        results.push(plugin.config.defaultSavePath = pth);
      } else {
        results.push(void 0);
      }
    }
    return results;
  };

  module.exports = ensurePaths;

}).call(this);
