// Generated by CoffeeScript 1.10.0
(function() {
  var loadDocument;

  loadDocument = function(plugin, docId, slug) {
    var config, content, docpad, document, err, error, error1, obj, tags;
    docpad = plugin.docpad;
    config = plugin.getConfig();
    try {
      document = plugin.findDocument(docId, slug);
    } catch (error) {
      err = error;
      return {
        success: false,
        msg: "couldn't find document",
        err: err
      };
    }
    try {
      if (document) {
        tags = document.meta.tags || [];
        if (typeof tags === 'string') {
          tags = [tags];
        }
        content = document.content;
        if (config.sendRenderedContent) {
          content = document.contentRenderedWithoutLayouts;
        }
        obj = {
          docId: docId,
          title: document.title,
          date: document.date,
          content: content,
          slug: document.slug,
          editdate: document.editdate,
          tags: tags,
          img: document.img,
          author: document.author,
          createdate: document.ctime,
          modifieddate: document.mtime,
          success: true
        };
        config.customFields.forEach(function(item) {
          return obj[item] = document[item];
        });
        return obj;
      } else {
        return {
          success: false,
          msg: "couldn't find document"
        };
      }
    } catch (error1) {
      err = error1;
      return {
        success: false,
        msg: "couldn't find document",
        err: err
      };
    }
  };

  module.exports = loadDocument;

}).call(this);
