// Generated by CoffeeScript 1.10.0
(function() {
  var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  module.exports = function(testers) {
    var PosteditorTester, beforeTest, expect, fs, pathUtil, request, util;
    expect = require('chai').expect;
    request = require('request');
    fs = require('safefs');
    util = require('util');
    pathUtil = require('path');
    beforeTest = require('./beforeTest');
    return PosteditorTester = (function(superClass) {
      extend(PosteditorTester, superClass);

      function PosteditorTester() {
        return PosteditorTester.__super__.constructor.apply(this, arguments);
      }

      PosteditorTester.prototype.testServer = function(next) {
        var dataPath, fileExists, ref, testSrcPosts, tester, versionPath;
        tester = this;
        PosteditorTester.__super__.testServer.apply(this, arguments);
        ref = beforeTest(tester), dataPath = ref.dataPath, versionPath = ref.versionPath, testSrcPosts = ref.testSrcPosts;
        fileExists = function(pathname) {
          var error;
          try {
            fs.statSync(pathname);
            return true;
          } catch (error) {
            return false;
          }
        };
        return this.suite('load and save documents', function(suite, test) {
          var baseUrl, config, plugin;
          plugin = tester.docpad.getPlugin('posteditor');
          config = plugin.getConfig();
          baseUrl = "http://localhost:" + tester.docpad.config.port;
          return this.suite('methods work as expected', function(suite, test, done) {
            test('data path exists', function() {
              var exists;
              exists = fileExists(dataPath);
              return expect(exists).to.be["true"];
            });
            test('version path exists', function() {
              var exists;
              exists = fileExists(versionPath);
              return expect(exists).to.be["true"];
            });
            test('load document 1262200515233', function() {
              var obj;
              obj = plugin.loadDocument(1262200515233, plugin);
              expect(obj.success).to.be["true"];
              test('document object has docId property', function() {
                return expect(obj.docId).to.equal(1262200515233);
              });
              test('document object has title property', function() {
                return expect(obj.title).to.equal('Bacon Prosciutto');
              });
              test('document object has content property', function() {
                return expect(obj.content).to.exist;
              });
              return test('document object has slug property', function() {
                console.log(obj.slug);
                return expect(obj.slug).to.equal('posts-bacon-prosciutto');
              });
            });
            test('save document works', function() {
              var newDoc, slug;
              slug = 'my-new-document';
              newDoc = {
                title: "My New Document",
                content: "Some content I've written. What do you thing?",
                user: {
                  name: 'johnsmith',
                  user_id: 123456
                },
                slug: slug
              };
              return plugin.saveDocument(plugin, newDoc, function(result) {
                expect(result.success).to.be["true"];
                return test('load new document', function() {
                  var doc, document;
                  doc = plugin.docpad.getCollection('posts').findOne({
                    slug: slug
                  });
                  expect(doc).to.not.be["null"];
                  document = doc.toJSON();
                  test('document has title', function() {
                    return expect(document.title).to.equal("My New Document");
                  });
                  test('document has slug', function() {
                    return expect(document.slug).to.equal(slug);
                  });
                  test('document has content', function() {
                    return expect(document.content).to.equal("Some content I've written. What do you thing?");
                  });
                  test('document has docId', function() {
                    return expect(document.docId).to.be.a("number");
                  });
                  test('document has edit_user', function() {
                    return expect(document).to.have.property('edit_user');
                  });
                  return test('document has edit_user_id', function() {
                    return expect(document).to.have.property('edit_user_id');
                  });
                });
              });
            });
            return done();
          });
        });
      };

      return PosteditorTester;

    })(testers.ServerTester);
  };

}).call(this);
