// Generated by CoffeeScript 1.10.0
(function() {
  var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  module.exports = function(testers) {
    var PosteditorTester, beforeTest, expect, fs, pathUtil, request, util;
    expect = require('chai').expect;
    request = require('request');
    fs = require('safefs');
    util = require('util');
    pathUtil = require('path');
    beforeTest = require('./beforeTest');
    return PosteditorTester = (function(superClass) {
      extend(PosteditorTester, superClass);

      function PosteditorTester() {
        return PosteditorTester.__super__.constructor.apply(this, arguments);
      }

      PosteditorTester.prototype.testServer = function(next) {
        var dataPath, ref, testSrcPosts, tester, versionPath;
        tester = this;
        PosteditorTester.__super__.testServer.apply(this, arguments);
        ref = beforeTest(tester), dataPath = ref.dataPath, versionPath = ref.versionPath, testSrcPosts = ref.testSrcPosts;
        return this.suite('server requests', function(suite, test) {
          var baseUrl, config, plugin;
          plugin = tester.docpad.getPlugin('posteditor');
          config = plugin.getConfig();
          baseUrl = "http://localhost:" + tester.docpad.config.port;
          test('get document', function(done) {
            var fileUrl;
            fileUrl = baseUrl + "/load/1262200515233";
            return request(fileUrl, function(err, response, body) {
              var obj;
              obj = JSON.parse(body);
              expect(err).to.not.be.ok;
              test('document object has docId property', function() {
                return expect(obj.docId).to.equal(1262200515233);
              });
              test('document object has title property', function() {
                return expect(obj.title).to.equal('Bacon Prosciutto');
              });
              test('document object has content property', function() {
                return expect(obj.content).to.exist;
              });
              test('document object has slug property', function() {
                return expect(obj.slug).to.equal('posts-bacon-prosciutto');
              });
              return done();
            });
          });
          return test('save document', function(done) {
            var fileUrl, newDoc, slug;
            slug = 'another-new-document';
            newDoc = {
              title: "Another New Document",
              content: "This is my content. What do you thing?",
              user: {
                name: 'johnsmith',
                user_id: 123456
              },
              slug: slug
            };
            fileUrl = baseUrl + "/save/";
            return request.post({
              url: fileUrl,
              form: newDoc
            }, function(err, response, body) {
              var obj;
              expect(err).to.not.be.ok;
              obj = JSON.parse(body);
              expect(obj.success).to.be["true"];
              test('document object has docId property', function() {
                return expect(obj.docId).to.be.a("number");
              });
              test('document object has title property', function() {
                return expect(obj.title).to.equal("Another New Document");
              });
              test('document object has content property', function() {
                return expect(obj.content).to.equal("This is my content. What do you thing?");
              });
              test('document object has slug property', function() {
                return expect(obj.slug).to.equal('another-new-document');
              });
              return done();
            });
          });
        });
      };

      return PosteditorTester;

    })(testers.ServerTester);
  };

}).call(this);
