// Generated by CoffeeScript 1.10.0
(function() {
  var dummyExpectedPath, fs, getDummies, getDummyFiles, getFileObject, layoutReg, path, readFile, slugify, titleReg;

  path = require('path');

  fs = require('fs');

  readFile = function(filename) {
    return fs.readFileSync(filename, 'utf-8');
  };

  slugify = function(input) {
    input = input.trim().toLowerCase();
    input = input.replace(/[^a-zA-Z0-9]/g, '-').replace(/^-/, '').replace(/-+/g, '-').trim();
    input = input.replace(/-$/, '').trim();
    return input;
  };

  titleReg = new RegExp(/title\s?:\s?(.*)/);

  layoutReg = new RegExp(/layout\s?:\s?(.*)/);

  getFileObject = function(filename) {
    var content, layout, title, txt;
    txt = readFile(filename);
    title = txt.match(titleReg);
    layout = txt.match(layoutReg);
    content = txt.split('---');
    return {
      title: title[1],
      layout: layout[1],
      content: content[2],
      slug: slugify(title[1]),
      file: filename
    };
  };

  getDummyFiles = function(dummyPath) {
    var files, items;
    items = fs.readdirSync(dummyPath);
    files = items.map(function(name, idx) {
      var file, stat;
      file = path.join(dummyPath, name);
      stat = fs.statSync(file);
      if (stat.isFile()) {
        return file;
      }
    });
    return files;
  };

  dummyExpectedPath = "";

  getDummies = function(tester) {
    var dummies, dummyFiles, dummyPath;
    dummyPath = path.join(tester.config.testPath, 'dummy-posts');
    dummyExpectedPath = path.join(tester.config.testPath, 'dummy-expected');
    dummyFiles = getDummyFiles(dummyPath);
    dummies = [];
    dummyFiles.forEach(function(file) {
      var obj;
      obj = getFileObject(file);
      return dummies.push(obj);
    });
    return dummies;
  };

  module.exports.getDummies = getDummies;

  module.exports.getFileObject = getFileObject;

  module.exports.dummyExpectedPath = function() {
    return dummyExpectedPath;
  };

}).call(this);
