// Generated by CoffeeScript 1.10.0
(function() {
  var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  module.exports = function(testers) {
    var PropertiesExistTester, cleanTestPaths, dataPath, expect, fs, path, request, testSrcPosts, util, versionPath;
    expect = require('chai').expect;
    request = require('request');
    fs = require('safefs');
    util = require('util');
    path = require('path');
    cleanTestPaths = require('./cleanTestPaths');
    dataPath = null;
    versionPath = null;
    testSrcPosts = null;
    return PropertiesExistTester = (function(superClass) {
      extend(PropertiesExistTester, superClass);

      function PropertiesExistTester() {
        return PropertiesExistTester.__super__.constructor.apply(this, arguments);
      }

      PropertiesExistTester.prototype.testCreate = function() {
        var ref, tester;
        tester = this;
        ref = cleanTestPaths(tester), dataPath = ref.dataPath, versionPath = ref.versionPath, testSrcPosts = ref.testSrcPosts;
        return PropertiesExistTester.__super__.testCreate.apply(this, arguments);
      };

      PropertiesExistTester.prototype.testGenerate = function() {
        var tester;
        tester = this;
        this.test("generate watch", function(done) {
          return tester.docpad.action('generate watch', function(err) {
            return done(err);
          });
        });
        return this;
      };

      PropertiesExistTester.prototype.testServer = function(next) {
        var fileExists, getDoc, getDocByTitle, makeOptions, tester;
        tester = this;
        PropertiesExistTester.__super__.testServer.apply(this, arguments);
        fileExists = function(pathname) {
          var error;
          try {
            fs.statSync(pathname);
            return true;
          } catch (error) {
            return false;
          }
        };
        getDoc = function() {
          return tester.docpad.getCollection('posts').findOne({
            docId: 1262200515233
          }).toJSON();
        };
        getDocByTitle = function(title) {
          return tester.docpad.getCollection('posts').findOne({
            title: title
          }).toJSON();
        };
        makeOptions = function(doc) {
          var opts;
          opts = {
            docId: doc.docId,
            content: doc.content,
            title: doc.title,
            tags: doc.tags,
            user: {
              name: 'johnsmith',
              user_id: 123456
            }
          };
          return opts;
        };
        return this.suite('regeneration', function(suite, test) {
          var config, content, doc, docpad, fullPath, plugin, testOutPosts;
          docpad = tester.docpad;
          plugin = docpad.getPlugin('posteditor');
          config = plugin.getConfig();
          testOutPosts = path.join(tester.config.testPath, 'out', 'posts');
          doc = getDoc();
          content = "";
          test('edit existing doc', function(done) {
            var opts;
            opts = makeOptions(doc);
            opts.content = 'xxx' + opts.content;
            content = opts.content.substr(0, 10);
            return plugin.saveDocument(plugin, opts, function(result) {
              expect(result.success).to.be["true"];
              return done();
            });
          });
          test('generate edit update', function(done) {
            return plugin.generateUpdate(1262200515233, doc.fullPath, function() {
              var newcontent, newdoc;
              newdoc = getDoc();
              newcontent = newdoc.content.substr(0, 10);
              expect(newcontent).to.equal(content);
              return done();
            });
          });
          fullPath = "";
          test('create new doc', function(done) {
            var filename, newDoc, title;
            content = "Some content I've written. What do you thing?";
            title = "My New Document";
            filename = title.replace(config.titleReg, '').trim().toLowerCase();
            filename = filename.replace(/[ ]/g, '-') + ".html.md";
            fullPath = path.join(testSrcPosts, filename);
            newDoc = {
              title: title,
              content: content,
              user: {
                name: 'johnsmith',
                user_id: 123456
              }
            };
            return plugin.saveDocument(plugin, newDoc, function(result) {
              expect(result.success).to.be["true"];
              return done();
            });
          });
          test('file exists before regeneration', function(done) {
            var isThere;
            isThere = fileExists(fullPath);
            expect(isThere).to.be["true"];
            return done();
          });
          test('generate new update', function(done) {
            return plugin.generateUpdate(null, doc.fullPath, function() {
              var isThere;
              isThere = fileExists(fullPath);
              expect(isThere).to.be["true"];
              return done();
            });
          });
          return test('document loaded in docpad collection', function(done) {
            var newdoc, title;
            title = "My New Document";
            newdoc = getDocByTitle(title);
            expect(newdoc).to.have.property('title');
            return done();
          });
        });
      };

      return PropertiesExistTester;

    })(testers.ServerTester);
  };

}).call(this);
