// Generated by CoffeeScript 1.10.0
(function() {
  var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  module.exports = function(testers) {
    var PosteditorTester, cleanTestPaths, dataPath, expect, fs, pathUtil, request, testSrcPosts, util, versionPath;
    expect = require('chai').expect;
    request = require('request');
    fs = require('safefs');
    util = require('util');
    pathUtil = require('path');
    cleanTestPaths = require('./cleanTestPaths');
    dataPath = null;
    versionPath = null;
    testSrcPosts = null;
    return PosteditorTester = (function(superClass) {
      extend(PosteditorTester, superClass);

      function PosteditorTester() {
        return PosteditorTester.__super__.constructor.apply(this, arguments);
      }

      PosteditorTester.prototype.testCreate = function() {
        var ref, tester;
        tester = this;
        ref = cleanTestPaths(tester), dataPath = ref.dataPath, versionPath = ref.versionPath, testSrcPosts = ref.testSrcPosts;
        return PosteditorTester.__super__.testCreate.apply(this, arguments);
      };

      PosteditorTester.prototype.testServer = function(next) {
        var tester;
        tester = this;
        PosteditorTester.__super__.testServer.apply(this, arguments);
        this.suite('request: load document', function(suite, test) {
          var baseUrl, config, obj, plugin;
          plugin = tester.docpad.getPlugin('posteditor');
          config = plugin.getConfig();
          baseUrl = "http://localhost:" + tester.docpad.config.port;
          obj = null;
          test('get document', function(done) {
            var fileUrl;
            fileUrl = baseUrl + "/load/1262200515233";
            return request(fileUrl, function(err, response, body) {
              obj = JSON.parse(body);
              console.log(obj);
              expect(err).to.not.be.ok;
              return done();
            });
          });
          test('document object has docId property', function(done) {
            expect(obj.docId).to.equal(1262200515233);
            return done();
          });
          test('document object has title property', function(done) {
            expect(obj.title).to.equal('Bacon Prosciutto');
            return done();
          });
          test('document object has content property', function(done) {
            expect(obj.content).to.exist;
            return done();
          });
          return test('document object has slug property', function(done) {
            expect(obj.slug).to.equal('posts-bacon-prosciutto');
            return done();
          });
        });
        return this.suite('request: save document', function(suite, test) {
          var baseUrl, fileUrl, newDoc, obj, slug;
          slug = 'another-new-document';
          newDoc = {
            title: "Another New Document",
            content: "This is my content. What do you thing?",
            user: {
              name: 'johnsmith',
              user_id: 123456
            },
            slug: slug
          };
          baseUrl = "http://localhost:" + tester.docpad.config.port;
          fileUrl = baseUrl + "/save/";
          obj = null;
          test('save document', function(done) {
            return request.post({
              url: fileUrl,
              form: newDoc
            }, function(err, response, body) {
              expect(err).to.not.be.ok;
              obj = JSON.parse(body);
              expect(obj.success).to.be["true"];
              return done();
            });
          });
          test('document object has docId property', function(done) {
            expect(obj.docId).to.be.a("number");
            return done();
          });
          test('document object has title property', function(done) {
            expect(obj.title).to.equal("Another New Document");
            return done();
          });
          test('document object has content property', function(done) {
            expect(obj.content).to.equal("This is my content. What do you thing?");
            return done();
          });
          return test('document object has slug property', function(done) {
            expect(obj.slug).to.equal('another-new-document');
            return done();
          });
        });
      };

      return PosteditorTester;

    })(testers.ServerTester);
  };

}).call(this);
