// Generated by CoffeeScript 1.10.0
(function() {
  var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  module.exports = function(testers) {
    var PosteditorTester, cleanTestPaths, dataPath, expect, fs, path, pathUtil, request, saveDocuments, testDocs, testOutPosts, testSrcPosts, util, versionPath;
    expect = require('chai').expect;
    request = require('request');
    fs = require('safefs');
    path = require('path');
    util = require('util');
    pathUtil = require('path');
    cleanTestPaths = require('./cleanTestPaths');
    testDocs = require('./testDocs');
    saveDocuments = require('../saveDocuments').methods;
    dataPath = null;
    versionPath = null;
    testSrcPosts = null;
    testOutPosts = null;
    return PosteditorTester = (function(superClass) {
      extend(PosteditorTester, superClass);

      function PosteditorTester() {
        return PosteditorTester.__super__.constructor.apply(this, arguments);
      }

      PosteditorTester.prototype.testCreate = function() {
        var ref, tester;
        tester = this;
        ref = cleanTestPaths(tester), dataPath = ref.dataPath, versionPath = ref.versionPath, testSrcPosts = ref.testSrcPosts, testOutPosts = ref.testOutPosts;
        return PosteditorTester.__super__.testCreate.apply(this, arguments);
      };

      PosteditorTester.prototype.testServer = function(next) {
        var doc1, doc2, fileExists, tester;
        tester = this;
        PosteditorTester.__super__.testServer.apply(this, arguments);
        fileExists = function(pathname) {
          var error;
          try {
            fs.statSync(pathname);
            return true;
          } catch (error) {
            return false;
          }
        };
        doc1 = testDocs[0];
        doc2 = testDocs[1];
        this.suite('mergeMetaData method', function(suite, test) {
          var docpad, document, fullPath, input, inputClone, opts, plugin, posts;
          docpad = tester.docpad;
          plugin = docpad.getPlugin('posteditor');
          posts = docpad.getCollection('posts').toJSON();
          document = posts[0];
          input = {
            docId: document.meta.docId,
            title: 'A New Title',
            newProp: 'some-property'
          };
          inputClone = JSON.parse(JSON.stringify(input));
          fullPath = null;
          opts = null;
          test('call mergeMetadData', function(done) {
            var ref;
            ref = saveDocuments.mergeMetaData(plugin, inputClone), fullPath = ref.fullPath, opts = ref.opts;
            expect(fullPath).to.equal(document.fullPath);
            expect(opts).to.not.equal(null);
            return done();
          });
          test('returns meta.title', function(done) {
            expect(opts.title).to.equal(input.title);
            return done();
          });
          test('returns meta.newProp', function(done) {
            expect(opts.newProp).to.equal(input.newProp);
            return done();
          });
          test('returns meta.docId', function(done) {
            expect(opts.docId).to.equal(input.docId);
            return done();
          });
          test('returns meta.slug', function(done) {
            expect(opts.slug).to.equal(document.slug);
            return done();
          });
          return test('returns meta.layout', function(done) {
            expect(opts.layout).to.equal(document.layout);
            return done();
          });
        });
        this.suite('buildContent method', function(suite, test) {
          var docMeta, docpad, fileContent, opts, plugin;
          docpad = tester.docpad;
          plugin = docpad.getPlugin('posteditor');
          fileContent = null;
          docMeta = null;
          opts = null;
          test('call buildContent', function(done) {
            var optsClone, ref;
            opts = JSON.parse(JSON.stringify(doc2));
            opts.docId = 1463223638676;
            optsClone = JSON.parse(JSON.stringify(opts));
            ref = saveDocuments.buildContent(optsClone, plugin), fileContent = ref.fileContent, docMeta = ref.docMeta;
            expect(docMeta).to.not.equal(null);
            expect(fileContent).to.be.string;
            return done();
          });
          test('returns docMeta.title', function(done) {
            expect(docMeta.title).to.equal(opts.title);
            return done();
          });
          test('returns docMeta.docId', function(done) {
            expect(docMeta.docId).to.equal(opts.docId);
            return done();
          });
          test('returns docMeta.author', function(done) {
            expect(docMeta.author).to.equal(opts.author);
            return done();
          });
          test('fileContent has expected content: docId', function(done) {
            var m;
            m = fileContent.search(/docId: 1463223638676/);
            expect(m).to.not.equal(-1);
            return done();
          });
          test('fileContent has expected content: title', function(done) {
            var m;
            m = fileContent.search(/title: Another New Document/);
            expect(m).to.not.equal(-1);
            return done();
          });
          test('fileContent has expected content: author', function(done) {
            var m;
            m = fileContent.search(/author: Ann Smith/);
            expect(m).to.not.equal(-1);
            return done();
          });
          test('fileContent has expected content: layout', function(done) {
            var m;
            m = fileContent.search(/layout: post/);
            expect(m).to.not.equal(-1);
            return done();
          });
          test('fileContent has expected content: edit_user', function(done) {
            var m;
            m = fileContent.search(/edit_user: annsmith/);
            expect(m).to.not.equal(-1);
            return done();
          });
          test('fileContent has expected content: edit_user_id', function(done) {
            var m;
            m = fileContent.search(/edit_user_id: 789123/);
            expect(m).to.not.equal(-1);
            return done();
          });
          test('fileContent has expected content: img', function(done) {
            var m;
            m = fileContent.search(/img:/);
            expect(m).to.equal(-1);
            return done();
          });
          test('fileContent has expected content: slug', function(done) {
            var m;
            m = fileContent.search(/slug: another-new-document/);
            expect(m).to.not.equal(-1);
            return done();
          });
          return test('fileContent has expected content: content', function(done) {
            var m;
            m = fileContent.search(/---\nThis is my content. What do you thing?/);
            expect(m).to.not.equal(-1);
            return done();
          });
        });
        this.suite('save new document', function(suite, test) {
          var config, docpad, fullPath, plugin, result;
          docpad = tester.docpad;
          plugin = docpad.getPlugin('posteditor');
          config = plugin.getConfig();
          result = null;
          fullPath = null;
          test('save document doc1', function(done) {
            var filename;
            filename = doc1.title.replace(config.titleReg, '').trim().toLowerCase();
            filename = filename.replace(/[ ]/g, '-') + ".html.md";
            fullPath = path.join(testSrcPosts, filename);
            return plugin.saveDocument(plugin, doc1, function(data) {
              console.log("doc1 saved..");
              result = data;
              expect(result.success).to.be["true"];
              return done();
            });
          });
          test('doc1 has title', function(done) {
            expect(result.title).to.equal(doc1.title);
            return done();
          });
          test('doc1 has content', function(done) {
            expect(result.content).to.equal(doc1.content);
            return done();
          });
          test('doc1 has author', function(done) {
            expect(result.author).to.equal(doc1.author);
            return done();
          });
          test('doc1 has slug', function(done) {
            expect(result.slug).to.equal(doc1.slug);
            return done();
          });
          test('doc1 has docId', function(done) {
            expect(result.title).to.be.number;
            return done();
          });
          return test('document exists on file system', function(done) {
            var isThere;
            isThere = fileExists(fullPath);
            expect(isThere).to.be["true"];
            return done();
          });
        });
        return this.suite('save existing document', function(suite, test) {
          var config, docpad, document, fullPath, opts, plugin, posts, result;
          docpad = tester.docpad;
          plugin = docpad.getPlugin('posteditor');
          config = plugin.getConfig();
          posts = docpad.getCollection('posts').toJSON();
          document = posts[0];
          fullPath = document.fullPath;
          opts = {
            docId: document.docId,
            content: "xxx" + document.content,
            title: "xxx" + document.title,
            author: document.author,
            tags: document.tags,
            img: document.img,
            slug: document.slug,
            user: {
              name: 'annsmith',
              user_id: 789123
            }
          };
          result = null;
          test('save document', function(done) {
            return plugin.saveDocument(plugin, opts, function(data) {
              console.log("document saved..");
              result = data;
              expect(result.success).to.be["true"];
              return done();
            });
          });
          test('document has title', function(done) {
            expect(result.title).to.equal(opts.title);
            return done();
          });
          test('document has content', function(done) {
            expect(result.content).to.equal(opts.content);
            return done();
          });
          test('document has author', function(done) {
            expect(result.author).to.equal(opts.author);
            return done();
          });
          test('document has slug', function(done) {
            expect(result.slug).to.equal(opts.slug);
            return done();
          });
          test('document has docId', function(done) {
            expect(result.docId).to.be.equal(opts.docId);
            return done();
          });
          return test('document exists on file system', function(done) {
            var isThere;
            isThere = fileExists(fullPath);
            expect(isThere).to.be["true"];
            return done();
          });
        });
      };

      return PosteditorTester;

    })(testers.ServerTester);
  };

}).call(this);
