// Generated by CoffeeScript 1.10.0
(function() {
  var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  module.exports = function(testers) {
    var StressTester, cleanTestPaths, dataPath, dummyFiles, expect, fs, path, request, testSrcPosts, util, versionPath;
    expect = require('chai').expect;
    request = require('request');
    fs = require('safefs');
    util = require('util');
    path = require('path');
    cleanTestPaths = require('./cleanTestPaths');
    dummyFiles = require('./dummyFiles');
    dataPath = null;
    versionPath = null;
    testSrcPosts = null;
    return StressTester = (function(superClass) {
      extend(StressTester, superClass);

      function StressTester() {
        return StressTester.__super__.constructor.apply(this, arguments);
      }

      StressTester.prototype.testCreate = function() {
        var ref, tester;
        tester = this;
        ref = cleanTestPaths(tester), dataPath = ref.dataPath, versionPath = ref.versionPath, testSrcPosts = ref.testSrcPosts;
        return StressTester.__super__.testCreate.apply(this, arguments);
      };

      StressTester.prototype.testServer = function(next) {
        var currentDocId, doRequest, dummyExpectedPath, dummyObjs, fileExists, longPost, readFile, runRequests, testOutPosts, tester, titleReg;
        tester = this;
        StressTester.__super__.testServer.apply(this, arguments);
        fileExists = function(pathname) {
          var error;
          try {
            fs.statSync(pathname);
            return true;
          } catch (error) {
            return false;
          }
        };
        readFile = function(filename) {
          return fs.readFileSync(filename, 'utf-8');
        };
        dummyObjs = dummyFiles.getDummies(tester);
        dummyExpectedPath = dummyFiles.dummyExpectedPath();
        testOutPosts = path.join(tester.config.testPath, 'out', 'posts');
        longPost = null;
        dummyObjs.forEach(function(item) {
          if (item.slug === 'long-text') {
            return longPost = item;
          }
        });
        currentDocId = null;
        doRequest = function(num) {
          var baseUrl, fileUrl, newDoc;
          baseUrl = "http://localhost:" + tester.docpad.config.port;
          fileUrl = baseUrl + "/save/";
          newDoc = {
            content: longPost.content,
            title: longPost.title + " " + num
          };
          if (currentDocId) {
            newDoc.docId = currentDocId;
          }
          return request.post({
            url: fileUrl,
            form: newDoc
          }, function(err, response, body) {
            var obj;
            expect(err).to.not.be.ok;
            obj = JSON.parse(body);
            expect(obj.success).to.be["true"];
            expect(obj.docId).to.be.number;
            return currentDocId = obj.docId;
          });
        };
        runRequests = function(howMany, mills, done) {
          var end, fn, i, v;
          i = 0;
          end = howMany;
          fn = function() {
            if (i > end) {
              clearInterval(v);
              console.log("done...");
              if (done) {
                return done();
              }
            } else {
              console.log("do request..." + i);
              doRequest(i);
              return i++;
            }
          };
          return v = setInterval(fn, mills);
        };
        titleReg = /<title>(.*)<\/title>/;
        return this.suite('volume check', function(suite, test) {
          return test('save document 100 times every 1/4 second', function(done) {
            runRequests(100, 250, done);
            test('100th saved (src) post current', function(done) {
              var file, fn;
              file = path.join(testSrcPosts, 'long-text-0.html.md');
              fn = function() {
                var fileObj;
                fileObj = dummyFiles.getFileObject(file);
                expect(fileObj.title).to.equal('Long Text 100');
                return done();
              };
              return setTimeout(fn, 1000);
            });
            return test('100th saved (out) post current', function(done) {
              var file, html, m, title;
              file = path.join(testOutPosts, 'long-text-0.html');
              html = readFile(file);
              m = html.match(titleReg);
              title = m[1];
              console.log(title);
              expect(title).to.equal('Long Text 100 | Your Website');
              return done();
            });
          });
        });
      };

      return StressTester;

    })(testers.ServerTester);
  };

}).call(this);
