// Generated by CoffeeScript 1.10.0
(function() {
  var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  module.exports = function(BasePlugin) {
    var PostEditorPlugin, URLS, fs, path, util;
    fs = require('safefs');
    path = require('path');
    URLS = require('url');
    util = require('util');
    return PostEditorPlugin = (function(superClass) {
      extend(PostEditorPlugin, superClass);

      function PostEditorPlugin() {
        return PostEditorPlugin.__super__.constructor.apply(this, arguments);
      }

      PostEditorPlugin.prototype.name = 'posteditor';

      PostEditorPlugin.prototype.config = {
        customFields: [],
        dataPath: null,
        defaultLayout: 'post',
        postCollection: 'posts',
        defaultSavePath: 'posts',
        saveVersions: true,
        loadURL: '/load/:docId',
        saveURL: '/save',
        generateURL: '/generate',
        sendRenderedContent: true,
        handleRegeneration: true,
        generateHomePage: true,
        sanitize: require('bleach').sanitize,
        titleReg: /[^A-Za-z0-9_.\-~\?!:"'$@# ]/g,
        allowArbitraryMetadata: false,
        allowableMetadata: ['title', 'layout', 'tags', 'img', 'docId', 'slug', 'editdate', 'edit_user', 'edit_user_id', 'author']
      };

      PostEditorPlugin.prototype.validPaths = [];

      PostEditorPlugin.prototype.ensurePaths = require('./helpers/ensurePaths');

      PostEditorPlugin.prototype.saveDocument = require('./helpers/saveDocuments').saveDocument;

      PostEditorPlugin.prototype.loadDocument = require('./helpers/loadDocuments');

      PostEditorPlugin.prototype.setConfig = function() {
        var loadURL, plugin;
        PostEditorPlugin.__super__.setConfig.apply(this, arguments);
        plugin = this;
        loadURL = plugin.getConfig().loadURL;
        if (loadURL.indexOf(':docId') < (loadURL.length - 6)) {
          plugin.docpad.warn("posteditor: loadURL incorrectly configured: " + loadURL);
        }
        return this.ensurePaths(this.docpad, plugin);
      };

      PostEditorPlugin.prototype.findDocument = function(docId, slug) {
        var document, id, model, qry;
        id = parseInt(docId);
        qry = {
          docId: id
        };
        if (!docId && slug) {
          slug = slug.replace(/^\//, '');
          qry = {
            slug: {
              $in: [slug, '/' + slug]
            }
          };
        }
        document = null;
        model = this.docpad.getCollection(this.config.postCollection).findOne(qry);
        if (model) {
          document = model.toJSON();
        }
        return document;
      };

      PostEditorPlugin.prototype.getUserDetails = function(req) {
        var name, user_id;
        name = "";
        user_id = -1;
        if (req && req.user) {
          name = req.user.name || req.user.username || req.user.screen_name || "";
          user_id = req.user.our_id || req.user.userid || req.user.user_id || req.user.id || -1;
        }
        return {
          name: name,
          id: user_id
        };
      };

      PostEditorPlugin.prototype.triggerGenerate = function(callback) {
        return this.docpad.action('generate', {
          reset: false
        }, function(err) {
          if (err) {
            return this.docpad.log("warn", "GENERATE ERROR IN POSTEDITOR");
          } else {
            if (callback) {
              return callback();
            }
          }
        });
      };

      PostEditorPlugin.prototype.generateUpdate = function(docId, fullPath, callback) {
        var config, index, model, stat;
        config = this.getConfig();
        if (config.generateHomePage) {
          index = this.docpad.getCollection('documents').findOne({
            relativeOutPath: 'index.html'
          });
          stat = index.getStat();
          stat.mtime = new Date();
          index.setStat(stat);
        }
        model = this.docpad.getCollection(this.config.postCollection).findOne({
          docId: docId
        });
        if (model) {
          model.load();
        } else {
          model = this.docpad.createModel({
            fullPath: fullPath
          });
          model.load();
          this.docpad.getDatabase().add(model);
        }
        return this.triggerGenerate(callback);
      };


      /*
      populateCollections: (opts,next) ->
          docpad = @docpad
          plugin = @
          user = @getUserDetails(null)
          collection = docpad.getCollection(@config.postCollection).findAllLive().forEach (doc) ->
              meta = doc.getAttributes().meta
              if(!meta.docId)
                  meta.content = doc.getContent()
                  meta.user = user
                  plugin.saveDocument(plugin,meta)
            
          next()
       */

      PostEditorPlugin.prototype.serverExtend = function(opts) {
        var config, docpad, docpadConfig, plugin, sanitize, server;
        server = opts.server;
        docpad = this.docpad;
        docpadConfig = docpad.getConfig();
        config = this.getConfig();
        plugin = this;
        sanitize = config.sanitize;
        server.get(config.loadURL, function(req, res, next) {
          var docId, obj, param, slug;
          param = req.params.docId;
          docId = isNaN(param) ? null : parseInt(param);
          slug = isNaN(param) ? param.replace(config.titleReg, '').trim() : null;
          obj = plugin.loadDocument(plugin, docId, slug);
          if (obj.success) {
            return res.json(obj);
          } else {
            return res.status(500).json(obj);
          }
        });
        server.post(config.saveURL, function(req, res, next) {
          var err, error, user;
          if (req.body.content && req.body.title) {
            user = plugin.getUserDetails(req);
            opts = req.body;
            opts.user = user;
            try {
              return plugin.saveDocument(plugin, opts, function(result) {
                if (result.success) {
                  return res.json(result);
                } else {
                  return res.status(500).json(result);
                }
              });
            } catch (error) {
              err = error;
              return res.status(500).json({
                success: false,
                msg: "Error saving document"
              });
            }
          } else {
            return res.status(500).json({
              success: false,
              msg: 'missing content or title'
            });
          }
        });
        server.post(config.generateURL, function(req, res, next) {
          var docId;
          if (req.body.docId) {
            docId = req.body.docId;
            if (typeof docId === "number" && !isNaN(docId)) {
              generateUpdate(docId, null, null);
              return res.json({
                success: true,
                msg: 'document ' + docId + " generated"
              });
            } else {
              return res.status(500).json({
                success: false,
                msg: 'docId not a number'
              });
            }
          } else {
            return res.status(500).json({
              success: false,
              msg: 'docId not a present'
            });
          }
        });
        return this;
      };

      return PostEditorPlugin;

    })(BasePlugin);
  };

}).call(this);
